--
-- Map Function Scripts
-- by Blacky_BPG
--

---------- DEFINITIONS ----------
Sektionaltor = {};

---------- VARIABLES ----------
local Sektionaltor_mt = Class(Sektionaltor);

---------- OBJECT CLASSES ----------

---------- SPECIAL FUNCTIONS ----------
function convertNumberToAbc(str)
	replacer = {};
	replacer[1] = "x";
	replacer[2] = "h";
	replacer[3] = "w";
	replacer[4] = "p";
	replacer[5] = "a";
	replacer[6] = "k";
	replacer[7] = "z";
	replacer[8] = "r";
	replacer[9] = "v";
	replacer[10] = "m";
	str = tostring(str);
	for i=1, 10 do
		str = string.gsub(str, tostring(i-1),replacer[i]);
	end;
	str = string.gsub(str, "-","c");
	return str;
end;

---------- ONCREATE FUNCTIONS ----------
function Sektionaltor.onCreate(id)
	g_currentMission:addUpdateable(Sektionaltor:new(id));
end;

---------- NEW FUNCTIONS ----------
function Sektionaltor:new(id, customMt)
	local instance = {};
	if customMt ~= nil then
		setmetatable(instance, customMt);
	else
		setmetatable(instance, Sektionaltor_mt);
	end;

	instance.triggerId = id;

	instance.manualOpen = Utils.getNoNil(getUserAttribute(id, "manualOpen"), false);
	instance.syncTimer = 33;
	instance.syncTimer2 = 333;
	-- instance.manualOpen = true;
	instance.canBeOpen = 1;
	instance.oldState = instance.canBeOpen;
	instance.playerInTrigger = false;
	if instance.manualOpen == true then
		instance.canBeOpen = 0;
		if getCollisionMask(id) ~= 15736832 then
			setCollisionMask(id,15736832);
		end;
	end;

	addTrigger(id, "triggerCallback", instance);

	instance.BarriersExtended = {};
	instance.fieldId = Utils.getNoNil(getUserAttribute(id, "fieldId"), -1);
	if instance.fieldId == 0 then
		instance.fieldId = -1;
	end;

	local audio = getUserAttribute(id, "audioIndex");
	if audio ~= nil then
		instance.audio = Utils.indexToObject(id, audio);
	else
		print("Error: Sektionaltor Audio index not correct or missing, Trigger deleted");
		self:delete();
	end;
	local colliId = getUserAttribute(id, "collisionBoxIndex");
	if colliId ~= nil then
		instance.colliIndex = Utils.indexToObject(id, colliId);
		instance.colliMask = getCollisionMask(instance.colliIndex);
	else
		print("Error: Sektionaltor collisionbox index not correct or missing, trigger deleted");
		self:delete();
		return
	end;
	instance.closeTime = Utils.getNoNil(getUserAttribute(id, "autoCloseTime"),0);
	if instance.closeTime > 0 then
		instance.closeTime = instance.closeTime * 1000;
	end;
	local lightGreen = getUserAttribute(id, "greenLightIndex");
	local lightRed = getUserAttribute(id, "redLightIndex");
	instance.statusLights = false;
	if lightGreen ~= nil and lightRed ~= nil then
		instance.statusLights = true;
		instance.lightGreen = Utils.indexToObject(id, lightGreen);
		instance.lightRed = Utils.indexToObject(id, lightRed);
	end;
	instance.speedScale = Utils.getNoNil(getUserAttribute(id, "speedScale"),10);
	instance.speedScale = instance.speedScale / 20;
	local li = getUserAttribute(id, "lightIndex");
	instance.lightIndex = nil;
	if li ~= nil then
		instance.lightIndex = Utils.indexToObject(id, li);
		instance.lightAllways = Utils.getNoNil(getUserAttribute(id, "lightsAllways"),false);
		instance.lightNightlight = Utils.getNoNil(getUserAttribute(id, "lightsNightlight"),true);
		instance.lightOn = Utils.getNoNil(getUserAttribute(id, "lightsOn"),20.5);
		instance.lightOff = Utils.getNoNil(getUserAttribute(id, "lightsOff"),6.5);
	end;

	local rootNode = getChild(id, "Sektion_1")
	instance.animCharSet = 0;
	if rootNode ~= nil then
		instance.animCharSet = getAnimCharacterSet(rootNode);
		if instance.animCharSet ~= 0 then
			local clipSource = getUserAttribute(id, "animationClip");
			if clipSource ~= nil then
				instance.clip = getAnimClipIndex(instance.animCharSet, clipSource);
				if instance.clip ~= nil then
					if instance.clip >= 0 then
						assignAnimTrackClip(instance.animCharSet, 0, instance.clip);
						setAnimTrackLoopState(instance.animCharSet, 0, false);
						setAnimTrackSpeedScale(instance.animCharSet, 0, instance.speedScale);
						instance.animDuration = getAnimClipDuration(instance.animCharSet, instance.clip);
					else
						print("Error: Sektionaltor clip for child Sektion_1 are not usable, trigger deleted");
						self:delete();
					end;
				else
					print("Error: Sektionaltor no clip named "..tostring(clipSource).." can be found in animation for child Sektion_1, trigger deleted");
					self:delete();
				end;
			else
				print("Error: Sektionaltor no clip name assigned for child Sektion_1, trigger deleted");
				self:delete();
			end;
		else
			print("Error: Sektionaltor no animation assigned for child Sektion_1, trigger deleted");
			self:delete();
		end;
	else
		print("Error: Sektionaltor no child Sektion_1 are found in assigned gate, trigger deleted");
		self:delete();
	end;

	instance.trafficAllowed = Utils.getNoNil(getUserAttribute(id, "trafficAllowed"), false);
	instance.AutoTimed = Utils.getNoNil(getUserAttribute(id, "AutoTimed"), false);
	instance.AutoOpen = true;
	instance.OpenTimed = Utils.getNoNil(getUserAttribute(id, "OpenTimed"), false);
	instance.OpenTime = Utils.getNoNil(getUserAttribute(id, "OpenTime"), 7.0);
	instance.CloseTime = Utils.getNoNil(getUserAttribute(id, "CloseTime"), 21.0);

	instance.randomClose = Utils.getNoNil(getUserAttribute(id, "randomClose"), false);
	instance.randomChance = Utils.getNoNil(getUserAttribute(id, "randomChance"), 25) / 2;
	instance.randomStart = 0;
	instance.randomEnd = 0;
	instance.randomActive = false;
	instance.randomRun = false;
	instance.randomText1 = Utils.getNoNil(getUserAttribute(id, "randomText1"), "default_noentry_msg");
	instance.randomText2 = Utils.getNoNil(getUserAttribute(id, "randomText2"), "default_noentry_msg");
	instance.randomText3 = Utils.getNoNil(getUserAttribute(id, "randomText3"), "default_noentry_msg");
	if instance.randomText1 == "" then
		instance.randomText1 = "default_noentry_msg";
	end;
	if instance.randomText2 == "" then
		instance.randomText2 = "default_noentry_msg";
	end;
	if instance.randomText3 == "" then
		instance.randomText3 = "default_noentry_msg";
	end;
	instance.randomActiveText = nil;

	local cSymbol = getUserAttribute(id, "CloseSymbol");
	if cSymbol ~= nil and cSymbol ~= "" then
		instance.cSymbol = Utils.indexToObject(id, cSymbol);
	end;
	local oSymbol = getUserAttribute(id, "OpenSymbol");
	if oSymbol ~= nil and oSymbol ~= "" then
		instance.oSymbol = Utils.indexToObject(id, oSymbol);
	end;

	local rul1 = getUserAttribute(id, "Rul1");
	if rul1 ~= nil and rul1 ~= "" then
		instance.rul1 = Utils.indexToObject(id, rul1);
	end;
	local rul2 = getUserAttribute(id, "Rul2");
	if rul2 ~= nil and rul2 ~= "" then
		instance.rul2 = Utils.indexToObject(id, rul2);
	end;

	if instance.rul1 ~= nil then
		setVisibility(instance.rul1, false);
	end;
	if instance.rul2 ~= nil then
		setVisibility(instance.rul2, false);
	end;

	instance.ownedByPlayer = false;

	instance.isEnabled = true;
	instance.trackTime = 0;
	instance.lastTrackTime = 0;
	instance.flickrCounter = 0;
	instance.autoCloseTimer = 0;

	if instance.audio ~= nil then
		setVisibility(instance.audio, false);
	end;
	if self.lightIndex ~= nil then
		setVisibility(self.lightIndex, false);
	end;

	instance.checkIntervall = 20;
	instance.Intervall = 10;
	instance.rulTime1 = 5;
	instance.rulTime2 = 15;
	instance.rulTime3 = 10;
	instance.rulShow = 0;
	instance.ctTime = 0;
	instance.hasRandomSend = false;

	instance.count = 0;
	instance.ccount = 0;
	instance.countBackup = 0;

	instance.setOpenState = Sektionaltor.setOpenState;

	instance.saveName = getUserAttribute(id, "triggerName");
	if instance.saveName == nil or instance.saveName == "" then
		local x,y,z = getWorldTranslation(id);
		x = math.floor(x * 100);
		y = math.floor(y * 100);
		z = math.floor(z * 100);
		instance.saveName = convertNumberToAbc(x..y..z);
	end;
	local x, y, z = getWorldTranslation(id);
	if x < 0 then
		x = 0 - x;
	end;
	if y < 0 then
		y = 0- y;
	end;
	if z < 0 then
		z = 0 - z;
	end;
	local sId = math.floor(x * 100) + math.floor(y * 100) + math.floor(z * 100);
	sId = math.floor(sId * 3.5);
	instance.mpName = sId;
	instance.tablePos = -1;
	instance.triggerIsAdded = false;

	return instance;
end;

---------- LOAD FUNCTIONS ----------

---------- LOADMAP FUNCTIONS ----------

---------- DELETE FUNCTIONS ----------
function Sektionaltor:delete()
	if self.triggerId ~= nil then
		removeTrigger(self.triggerId);
	end;
end;

---------- DELETEMAP FUNCTIONS ----------

---------- UPDATE FUNCTIONS ----------
function Sektionaltor:update(dt)
	if self.triggerIsAdded == false then
		if g_currentMission.barrierTriggers ~= nil then
			table.insert(g_currentMission.barrierTriggers, self);
			self.tablePos = table.getn(g_currentMission.barrierTriggers);
			self.triggerIsAdded = true;
		else
			g_currentMission.barrierTriggers = {};
			table.insert(g_currentMission.barrierTriggers, self);
			self.tablePos = table.getn(g_currentMission.barrierTriggers);
			self.triggerIsAdded = true;
		end;
	end;

	if self.Intervall >= self.checkIntervall then
		self.Intervall = 0;
	else
		self.Intervall = self.Intervall + 1;
	end;

	if self.manualOpen == true then
		self.closeTime = 0;
		if self.playerInTrigger == true and g_currentMission.player.canDrawOpen then
			if g_gui.currentGui == nil or g_gui.currentGuiName ~= "ChatDialog" then
			if InputBinding.hasEvent(InputBinding.OPEN_GATE) then
				if self.canBeOpen == 0 then
					self.canBeOpen = 2;
				else
					self.canBeOpen = 0;
				end;
				OpenTriggerManager:setOpenState(self.tablePos, self.mpName, self.canBeOpen);
			end;
			end;
		end;
	elseif self.canBeOpen ~= 1 then
		self.canBeOpen = 1;
	end;

	if self.syncTimer2 > 0 then
		self.syncTimer2 = self.syncTimer2 - 1;
	else
		if self.hasRandomSend then
			self.hasRandomSend = false;
		end;
	end;

	if self.fieldId == -1 then
		self.ownedByPlayer = true;
	else
		if self.Intervall == 1 then
			self.ownedByPlayer = false;
			if g_currentMission.fieldDefinitionBase.fieldDefs[self.fieldId].ownedByPlayer then
				self.ownedByPlayer = true;
			else
				self.ownedByPlayer = false;
			end;
		end;
	end;

	self.AutoOpen = true;
	local ctime = math.floor(g_currentMission.environment.dayTime / 3600 / 10) / 100;

	if self.AutoTimed == true or self.OpenTimed then
		if (ctime < self.OpenTime) or (ctime > self.CloseTime) then
			self.AutoOpen = false;
			self.count = 0;
			if self.cSymbol ~= nil then
				setVisibility(self.cSymbol, true);
			end;
			if self.oSymbol ~= nil then
				setVisibility(self.oSymbol, false);
			end;
		else
			if self.OpenTimed == false then
				self.count = 1;
			end;
			if self.cSymbol ~= nil then
				setVisibility(self.cSymbol, false);
			end;
			if self.oSymbol ~= nil then
				setVisibility(self.oSymbol, true);
			end;
		end;
	end;

	if self.randomClose then
		if self.randomActive == false and self.Intervall == 10 then
			local tActive = math.random(1, 100);
			if tActive >= (50 - self.randomChance) and tActive < (50 + self.randomChance) then
				self.randomActive = true;
				self.randomStart = math.random(0, 23);
				self.randomEnd = math.random(self.randomStart + 1, self.randomStart + 5);
				local tText = math.random(1, 9);
				if tText >= 1 and tText < 3 then
					self.randomActiveText = self.randomText1;
				elseif tText >= 3 and tText < 6 then
					self.randomActiveText = self.randomText2;
				else
					self.randomActiveText = self.randomText3;
				end;
			end;
		else
			if g_currentMission.missionDynamicInfo.isMultiplayer and g_server ~= nil then
				if not self.hasRandomSend then
					self.hasRandomSend = true;
					self.syncTimer2 = 666;
					OpenTriggerManager:setRandomState(self.mpName, self.randomActive, self.randomStart, self.randomEnd, self.randomActiveText);
				end;
			end;
			if self.randomEnd > 23.9 then
				ctime = ctime + 24;
			end;
			if (ctime < self.randomEnd) and (ctime > self.randomStart) then
				self.randomRun = true;
				if self.cSymbol ~= nil then
					setVisibility(self.cSymbol, true);
				end;
				if self.oSymbol ~= nil then
					setVisibility(self.oSymbol, false);
				end;
			end;
			if self.randomRun == true then
				if self.count > 0 then
					local fixTime = self.randomEnd;
					if fixTime > 24 then
						fixTime = fixTime - 24;
					end;
					local msg = g_i18n:getText(self.randomActiveText).." "..tostring(fixTime).." "..g_i18n:getText("default_noentry_clock");
					g_currentMission:addWarning(msg, 0.018, 0.033);
				end;
				if ctime > self.randomEnd then
					self.randomRun = false;
					self.hasRandomSend = false;
					self.randomActive = false;
					self.randomStart = 0;
					self.randomEnd = 0;
					self.randomActiveText = nil;
				end;
			end;
		end;
	end;

	if self.randomRun == true then
		local vis1 = false;
		local vis2 = false;
		self.rulShow = self.rulShow + 1;
		if self.rulShow >= (self.rulTime1 / 2) then
			vis1 = false;
			vis2 = false;
		end;
		if self.rulShow == (self.rulTime3 / 2) then
			self.rulShow = 0;
			vis1 = true;
			vis2 = true;
		end;

		if self.rul1 ~= nil then
			setVisibility(self.rul1, vis1);
		end;
		if self.rul2 ~= nil then
			setVisibility(self.rul2, vis2);
		end;
	end;

	local ctime = math.floor(g_currentMission.environment.dayTime / 3600 / 10) / 100;

	if self.lightIndex ~= nil then
		if self.lightAllways == true then
			if self.lightNightlight == true then
				if ctime >= self.lightOn or ctime < self.lightOff then
					setVisibility(self.lightIndex, true);
				end;
			else
				setVisibility(self.lightIndex, true);
			end;
		end;
	end;

	if self.trackTime < 1 then
		self.trackTime = 0;
	end;

	if self.trackTime > self.animDuration then
		self.trackTime = self.animDuration;
	end;

	if self.ownedByPlayer == true and self.AutoOpen == true and self.randomRun == false and self.canBeOpen > 0 then
		if self.count > 0 or self.canBeOpen > 1 then
			if self.lightIndex ~= nil then
				if self.lightAllways ~= true then
					if (self.lightNightlight == true and (ctime >= self.lightOn or ctime < self.lightOff)) or self.lightNightlight ~= true then
						if self.flickrCounter == 0 or self.flickrCounter == 4 or self.flickrCounter == 8 or self.flickrCounter >= 13 then
							setVisibility(self.lightIndex, true);
						elseif self.flickrCounter == 2 or self.flickrCounter == 5 or self.flickrCounter == 11 then
							setVisibility(self.lightIndex, false);
						end;
						if self.flickrCounter < 14 then
							self.flickrCounter = self.flickrCounter + 1;
						end;
					end;
				end;
			end;
			if self.autoCloseTimer <= ctime and self.closeTime > 0 then
				self.countBackup = self.count;
				self.count = 0;
			end;
			if self.trackTime < self.animDuration then
				self.trackTime = self.trackTime + 10 * self.speedScale;
			end;
			if self.trackTime >= (self.animDuration / 2) then
				setCollisionMask(self.colliIndex,0);
				if self.statusLights == true then
					if getVisibility(self.lightRed) then
						setVisibility(self.lightGreen, true);
						setVisibility(self.lightRed, false);
					end;
				end;
			end;
		else
			self.autoCloseTimer = 0;
			if self.trackTime > 0 then
				self.trackTime = self.trackTime - 10 * self.speedScale;
				if self.trackTime <= (self.animDuration / 2) then
					setCollisionMask(self.colliIndex,self.colliMask);
					if self.statusLights == true then
						if getVisibility(self.lightGreen) then
							setVisibility(self.lightGreen, false);
							setVisibility(self.lightRed, true);
						end;
					end;
				end;
			else
				if self.lightIndex ~= nil then
					if self.lightAllways ~= true then
						if getVisibility(self.lightIndex) then
							setVisibility(self.lightIndex, false);
						end;
					end;
					self.flickrCounter = 0;
				end;
			end;
		end;
	else
		self.autoCloseTimer = 0;
		if self.trackTime > 0 then
			self.trackTime = self.trackTime - 10 * self.speedScale;
			if self.trackTime <= (self.animDuration / 2) then
				setCollisionMask(self.colliIndex,self.colliMask);
				if self.statusLights == true then
					if getVisibility(self.lightGreen) then
						setVisibility(self.lightGreen, false);
						setVisibility(self.lightRed, true);
					end;
				end;
			end;
		else
			if self.lightIndex ~= nil then
				if self.lightAllways ~= true then
					if getVisibility(self.lightIndex) then
						setVisibility(self.lightIndex, false);
					end;
				end;
				self.flickrCounter = 0;
			end;
		end;
	end;

	if self.lastTrackTime ~= self.trackTime then
		if self.audio ~= nil then
			if not getVisibility(self.audio) then
				setVisibility(self.audio, true);
			end;
		end;
		enableAnimTrack(self.animCharSet, self.clip);
		setAnimTrackTime(self.animCharSet, self.clip, self.trackTime, true);
		disableAnimTrack(self.animCharSet, self.clip);
		self.lastTrackTime = self.trackTime;
	else
		if self.audio ~= nil then
			if getVisibility(self.audio) then
				setVisibility(self.audio, false);
			end;
		end;
	end;
end;

---------- TRIGGER CALLBACK FUNCTIONS ----------
function Sektionaltor:triggerCallback(triggerId, otherId, onEnter, onLeave, onStay)
	if g_currentMission ~= nil then
		local pName = nil;
		if g_currentMission.player ~= nil then
			pName = g_currentMission.player.controllerName;
			if g_currentMission.player.rootNode == otherId then
				if onEnter and self.isEnabled then
					if self.manualOpen == true then
						self.playerInTrigger = true;
						g_currentMission.player.canDrawOpen = true;
					end;
					if self.closeTime > 0 then
						self.autoCloseTimer = (g_currentMission.environment.dayTime + ((10 * self.speedScale * 1000) + self.closeTime) * g_currentMission.missionStats.timeScale);
					end;
					self.count = self.count + self.countBackup;
					self.countBackup = 0;
				elseif onLeave then
					g_currentMission.player.canDrawOpen = false;
					self.playerInTrigger = false;
				end;
			end;
		end;

		local vehicle = g_currentMission.nodeToVehicle[otherId];
		if vehicle ~= nil then
			local canBe = true;
			if SpecializationUtil.hasSpecialization(TrafficVehicle, vehicle.specializations) or SpecializationUtil.hasSpecialization(PathVehicle, vehicle.specializations) then
				if not self.trafficAllowed then
					canBe = false;
				end;
			end;
			if canBe then
				if vehicle.isControlled ~= nil and pName ~= nil and pName == vehicle.controllerName then
					if onEnter and self.isEnabled then
						self.count = self.count + 1;
						self.ccount = self.ccount + 1;
						if self.manualOpen == true then
							self.playerInTrigger = true;
							vehicle.canDrawOpen = true;
							g_currentMission.player.canDrawOpen = true;
						end;
						if self.closeTime > 0 then
							self.autoCloseTimer = (g_currentMission.environment.dayTime + ((10 * self.speedScale * 1000) + self.closeTime) * g_currentMission.missionStats.timeScale);
						end;
						self.count = self.count + self.countBackup;
						self.countBackup = 0;
					elseif onLeave then
						self.count = self.count - 1;
						if self.countBackup > 0 then
							self.countBackup = self.countBackup - 1;
						end;
						self.ccount = self.ccount - 1;
						if self.ccount <= 0 then
							vehicle.canDrawOpen = false;
							self.playerInTrigger = false;
							g_currentMission.player.canDrawOpen = false;
							self.ccount = 0;
						end;
						if self.count <= 0 then
							vehicle.canDrawOpen = false;
							self.playerInTrigger = false;
							g_currentMission.player.canDrawOpen = false;
							self.count = 0;
						end;
					end;
				else
					if onEnter and self.isEnabled then
						self.count = self.count + 1;
						if self.closeTime > 0 then
							self.autoCloseTimer = (g_currentMission.environment.dayTime + ((10 * self.speedScale * 1000) + self.closeTime) * g_currentMission.missionStats.timeScale);
						end;
						self.count = self.count + self.countBackup;
						self.countBackup = 0;
					elseif onLeave then
						self.count = self.count - 1;
						if self.countBackup > 0 then
							self.countBackup = self.countBackup - 1;
						end;
						if self.count <= 0 then
							self.count = 0;
							vehicle.canDrawOpen = false;
							self.playerInTrigger = false;
							g_currentMission.player.canDrawOpen = false;
						end;
					end;
				end;
			end;
		end;
	end;
end;

---------- OTHER FUNCTIONS ----------
function Sektionaltor:setOpenState(state)
	if state ~= nil then
		self.canBeOpen = state;
	end;
end;

---------- DRAW FUNCTIONS ----------

---------- SPECIFIC FUNCTIONS ----------

---------- ALL OTHER FUNCTIONS ----------

---------- NETWORK FUNCTIONS ----------

---------- EVENT FUNCTIONS COMPLETE ----------

---------- APPEND FUNCTIONS PROCEDURES ----------

---------- CREATE AND LISTENER CALLS ----------
g_onCreateUtil.addOnCreateFunction("SektionaltorOnCreate", Sektionaltor.onCreate);
